/*
Contents:
	JavaScript for processing OLIF data with MSXML
Dependencies (this file depends on the presence of):

Contact:
        www.olif.net
Status:
	Copyright (C) 2001, OLIF Consortium
Version:
	$DateTime: 2001/11/06 15:47:30 $
	$Revision: #1 $
Last Changed by:
	Christian Lieske - SAP AG - MultiLingual Technology
*/

// wrapper function for processing XML data island with XSL
function call(xslIsland,xmlIsland){ 
	// generate XML documents (xslTemplate speeds up processing)
	var xslDoc=new ActiveXObject("MSXML2.FreeThreadedDOMDocument");
	var rsltDoc=new	ActiveXObject("MSXML2.FreeThreadedDOMDocument");
	var xslTemplate=new ActiveXObject("MSXML2.XSLTemplate");

	// retrieve DOM for XSL from property of XML data island which has been
	// passed in as parameter
	xslDoc.load(xslIsland.XMLDocument);
	
	// attach the XSL template to the XSL
	xslTemplate.stylesheet=xslDoc;

	// create an XSL processor
	var xslProc=xslTemplate.createProcessor();

	// tell the XSL processor where to get the input and where to write
	// the output
	xslProc.input=xmlIsland.XMLDocument;
	xslProc.output=rsltDoc;

	// pass optional parameters to XSL processor
	if (arguments.length >2 && 
		arguments.length % 2 == 0){
		for (var i=0;
			i<Math.floor((arguments.length)/2)-1;
			i++){	
			paramName=arguments[2*i+2];
			paramValue=arguments[2*i+3];
			xslProc.addParameter(paramName,paramValue);
			}
		}
	
	// start the XSL transformation
	xslProc.transform();

	// return the resulting XML
	return rsltDoc;
}
	
// function for processing records
function processRecords(sortKey,sortOrder,xmlData,stylesheet){
	// initiate the XSL processing
	var htmlDoc= call(stylesheet,xmlData,"sortKey",sortKey,"sortOrder",sortOrder);
	// display the resulting HTML in the division termed 'displayArea'
	window.displayArea.innerHTML=htmlDoc.xml;
}
